OGRE: Ogre::MovableObjectFactory Class Reference - OGRE Documentation

Main Page | Namespace List | Class Hierarchy | Alphabetical List | Class List | Directories | File List | Namespace Members | Class Members | File Members | Related Pages

# Ogre::MovableObjectFactory Class Reference

Interface definition for a factory class which produces a certain kind of MovableObject, and can be registered with Root in order to allow all clients to produce new instances of this object, integrated with the standard Ogre processing. More...

`#include <OgreMovableObject.h>`

Inheritance diagram for Ogre::MovableObjectFactory:

[legend]
List of all members.

## Public Member Functions

| MovableObjectFactory ()
virtual | ~MovableObjectFactory ()
virtual const String & | getType (void) const =0
| Get the type of the object to be created.
virtual MovableObject * | createInstance (const String &name, SceneManager *manager, const NameValuePairList *params=0)
| Create a new instance of the object.
virtual void | destroyInstance (MovableObject *obj)=0
| Destroy an instance of the object.
virtual bool | requestTypeFlags (void) const
| Does this factory require the allocation of a 'type flag', used to selectively include / exclude this type from scene queries?
void | _notifyTypeFlags (unsigned long flag)
| Notify this factory of the type mask to apply.
unsigned long | getTypeFlags (void) const
| Gets the type flag for this factory.

## Protected Member Functions

virtual MovableObject * | createInstanceImpl (const String &name, const NameValuePairList *params=0)=0
| Internal implementation of create method - must be overridden.

## Protected Attributes

unsigned long | mTypeFlag
| Type flag, allocated if requested.

## Detailed Description

Interface definition for a factory class which produces a certain kind of MovableObject, and can be registered with Root in order to allow all clients to produce new instances of this object, integrated with the standard Ogre processing.

Definition at line 468 of file OgreMovableObject.h.

## Constructor & Destructor Documentation

Ogre::MovableObjectFactory::MovableObjectFactory | ( |  | ) |

| Definition at line 478 of file OgreMovableObject.h.

virtual Ogre::MovableObjectFactory::~MovableObjectFactory | ( |  | ) | `[virtual]`

| Definition at line 479 of file OgreMovableObject.h.

## Member Function Documentation

void Ogre::MovableObjectFactory::_notifyTypeFlags | ( | unsigned long | flag | ) |

Notify this factory of the type mask to apply.

Remarks:
  This should normally only be called by Root in response to a 'true' result from requestTypeMask. However, you can actually use it yourself if you're careful; for example to assign the same mask to a number of different types of object, should you always wish them to be treated the same in queries.

Definition at line 518 of file OgreMovableObject.h.

virtual MovableObject* Ogre::MovableObjectFactory::createInstance | ( | const String & | name,
|  | SceneManager * | manager,
|  | const NameValuePairList * | params = `0`
| ) | `[virtual]`

Create a new instance of the object.

Parameters:

  | name | The name of the new object
  | manager | The SceneManager instance that will be holding the instance once created.
  | params | Name/value pair list of additional parameters required to construct the object (defined per subtype). Optional.

virtual MovableObject* Ogre::MovableObjectFactory::createInstanceImpl | ( | const String & | name,
|  | const NameValuePairList * | params = `0`
| ) | `[protected, pure virtual]`

| Internal implementation of create method - must be overridden. Implemented in Ogre::BillboardChainFactory, Ogre::BillboardSetFactory, Ogre::EntityFactory, Ogre::LightFactory, Ogre::ManualObjectFactory, Ogre::ParticleSystemFactory, and Ogre::RibbonTrailFactory.

virtual void Ogre::MovableObjectFactory::destroyInstance | ( | MovableObject * | obj | ) | `[pure virtual]`

| Destroy an instance of the object. Implemented in Ogre::BillboardChainFactory, Ogre::BillboardSetFactory, Ogre::EntityFactory, Ogre::LightFactory, Ogre::ManualObjectFactory, Ogre::ParticleSystemFactory, and Ogre::RibbonTrailFactory.

virtual const String& Ogre::MovableObjectFactory::getType | ( | void |  | ) | const`[pure virtual]`

| Get the type of the object to be created. Implemented in Ogre::BillboardChainFactory, Ogre::BillboardSetFactory, Ogre::EntityFactory, Ogre::LightFactory, Ogre::ManualObjectFactory, Ogre::ParticleSystemFactory, and Ogre::RibbonTrailFactory.

unsigned long Ogre::MovableObjectFactory::getTypeFlags | ( | void |  | ) | const

Gets the type flag for this factory.

Remarks:
  A type flag is like a query flag, except that it applies to all instances of a certain type of object.

Definition at line 525 of file OgreMovableObject.h.

virtual bool Ogre::MovableObjectFactory::requestTypeFlags | ( | void |  | ) | const`[virtual]`

Does this factory require the allocation of a 'type flag', used to selectively include / exclude this type from scene queries?

Remarks:
  The default implementation here is to return 'false', ie not to request a unique type mask from Root. For objects that never need to be excluded in SceneQuery results, that's fine, since the default implementation of MovableObject::getTypeFlags is to return all ones, hence matching any query type mask. However, if you want the objects created by this factory to be filterable by queries using a broad type, you have to give them a (preferably unique) type mask - and given that you don't know what other MovableObject types are registered, Root will allocate you one.

Definition at line 509 of file OgreMovableObject.h.

## Member Data Documentation

unsigned long Ogre::MovableObjectFactory::mTypeFlag`[protected]`

| Type flag, allocated if requested. Definition at line 472 of file OgreMovableObject.h.

The documentation for this class was generated from the following file:

- OgreMovableObject.h

Copyright © 2000-2005 by The OGRE Team
This work is licensed under a Creative Commons Attribution-ShareAlike 2.5 License.
Last modified Thu Mar 6 09:47:22 2008